// GENERATED CODE - DO NOT MODIFY BY HAND
// This code was generated by ObjectBox. To update it run the generator again
// with `dart run build_runner build`.
// See also https://docs.objectbox.io/getting-started#generate-objectbox-code

// ignore_for_file: camel_case_types, depend_on_referenced_packages
// coverage:ignore-file

import 'dart:typed_data';

import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'package:objectbox/internal.dart'
    as obx_int; // generated code can access "internal" functionality
import 'package:objectbox/objectbox.dart' as obx;
import 'package:objectbox_flutter_libs/objectbox_flutter_libs.dart';

import 'main.dart';

export 'package:objectbox/objectbox.dart'; // so that callers only have to import this file

final _entities = <obx_int.ModelEntity>[
  obx_int.ModelEntity(
      id: const obx_int.IdUid(1, 779069174120007465),
      name: 'SequenceDto',
      lastPropertyId: const obx_int.IdUid(4, 2497061460234676470),
      flags: 0,
      properties: <obx_int.ModelProperty>[
        obx_int.ModelProperty(
            id: const obx_int.IdUid(1, 8149606947296174824),
            name: 'id',
            type: 6,
            flags: 1),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(2, 924752720085173269),
            name: 'panoramaxSequenceId',
            type: 9,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(3, 2213911384116253207),
            name: 'name',
            type: 9,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(4, 2497061460234676470),
            name: 'creationDate',
            type: 10,
            flags: 0)
      ],
      relations: <obx_int.ModelRelation>[],
      backlinks: <obx_int.ModelBacklink>[
        obx_int.ModelBacklink(
            name: 'pictures',
            srcEntity: 'SequencePictureDto',
            srcField: 'sequence')
      ]),
  obx_int.ModelEntity(
      id: const obx_int.IdUid(2, 1783411209866357886),
      name: 'SequencePictureDto',
      lastPropertyId: const obx_int.IdUid(6, 1128543006418784658),
      flags: 0,
      properties: <obx_int.ModelProperty>[
        obx_int.ModelProperty(
            id: const obx_int.IdUid(1, 8632920558644460697),
            name: 'id',
            type: 6,
            flags: 1),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(2, 3842239925963027546),
            name: 'localFilePath',
            type: 9,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(3, 3839909268889298365),
            name: 'isToSend',
            type: 1,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(4, 1759602370318792855),
            name: 'hasBeenSent',
            type: 1,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(5, 8307842829806638423),
            name: 'doesImageHaveCorrectExifTags',
            type: 1,
            flags: 0),
        obx_int.ModelProperty(
            id: const obx_int.IdUid(6, 1128543006418784658),
            name: 'sequenceId',
            type: 11,
            flags: 520,
            indexId: const obx_int.IdUid(1, 1043436542397485338),
            relationTarget: 'SequenceDto')
      ],
      relations: <obx_int.ModelRelation>[],
      backlinks: <obx_int.ModelBacklink>[])
];

/// Shortcut for [obx.Store.new] that passes [getObjectBoxModel] and for Flutter
/// apps by default a [directory] using `defaultStoreDirectory()` from the
/// ObjectBox Flutter library.
///
/// Note: for desktop apps it is recommended to specify a unique [directory].
///
/// See [obx.Store.new] for an explanation of all parameters.
///
/// For Flutter apps, also calls `loadObjectBoxLibraryAndroidCompat()` from
/// the ObjectBox Flutter library to fix loading the native ObjectBox library
/// on Android 6 and older.
Future<obx.Store> openStore(
    {String? directory,
    int? maxDBSizeInKB,
    int? maxDataSizeInKB,
    int? fileMode,
    int? maxReaders,
    bool queriesCaseSensitiveDefault = true,
    String? macosApplicationGroup}) async {
  await loadObjectBoxLibraryAndroidCompat();
  return obx.Store(getObjectBoxModel(),
      directory: directory ?? (await defaultStoreDirectory()).path,
      maxDBSizeInKB: maxDBSizeInKB,
      maxDataSizeInKB: maxDataSizeInKB,
      fileMode: fileMode,
      maxReaders: maxReaders,
      queriesCaseSensitiveDefault: queriesCaseSensitiveDefault,
      macosApplicationGroup: macosApplicationGroup);
}

/// Returns the ObjectBox model definition for this project for use with
/// [obx.Store.new].
obx_int.ModelDefinition getObjectBoxModel() {
  final model = obx_int.ModelInfo(
      entities: _entities,
      lastEntityId: const obx_int.IdUid(2, 1783411209866357886),
      lastIndexId: const obx_int.IdUid(1, 1043436542397485338),
      lastRelationId: const obx_int.IdUid(0, 0),
      lastSequenceId: const obx_int.IdUid(0, 0),
      retiredEntityUids: const [],
      retiredIndexUids: const [],
      retiredPropertyUids: const [],
      retiredRelationUids: const [],
      modelVersion: 5,
      modelVersionParserMinimum: 5,
      version: 1);

  final bindings = <Type, obx_int.EntityDefinition>{
    SequenceDto: obx_int.EntityDefinition<SequenceDto>(
        model: _entities[0],
        toOneRelations: (SequenceDto object) => [],
        toManyRelations: (SequenceDto object) => {
              obx_int.RelInfo<SequencePictureDto>.toOneBacklink(6, object.id,
                      (SequencePictureDto srcObject) => srcObject.sequence):
                  object.pictures
            },
        getId: (SequenceDto object) => object.id,
        setId: (SequenceDto object, int id) {
          object.id = id;
        },
        objectToFB: (SequenceDto object, fb.Builder fbb) {
          final panoramaxSequenceIdOffset = object.panoramaxSequenceId == null
              ? null
              : fbb.writeString(object.panoramaxSequenceId!);
          final nameOffset = fbb.writeString(object.name);
          fbb.startTable(5);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, panoramaxSequenceIdOffset);
          fbb.addOffset(2, nameOffset);
          fbb.addInt64(3, object.creationDate.millisecondsSinceEpoch);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (obx.Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = SequenceDto()
            ..id = const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0)
            ..panoramaxSequenceId =
                const fb.StringReader(asciiOptimization: true)
                    .vTableGetNullable(buffer, rootOffset, 6)
            ..name = const fb.StringReader(asciiOptimization: true)
                .vTableGet(buffer, rootOffset, 8, '')
            ..creationDate = DateTime.fromMillisecondsSinceEpoch(
                const fb.Int64Reader().vTableGet(buffer, rootOffset, 10, 0));
          obx_int.InternalToManyAccess.setRelInfo<SequenceDto>(
              object.pictures,
              store,
              obx_int.RelInfo<SequencePictureDto>.toOneBacklink(6, object.id,
                  (SequencePictureDto srcObject) => srcObject.sequence));
          return object;
        }),
    SequencePictureDto: obx_int.EntityDefinition<SequencePictureDto>(
        model: _entities[1],
        toOneRelations: (SequencePictureDto object) => [object.sequence],
        toManyRelations: (SequencePictureDto object) => {},
        getId: (SequencePictureDto object) => object.id,
        setId: (SequencePictureDto object, int id) {
          object.id = id;
        },
        objectToFB: (SequencePictureDto object, fb.Builder fbb) {
          final localFilePathOffset = fbb.writeString(object.localFilePath);
          fbb.startTable(7);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, localFilePathOffset);
          fbb.addBool(2, object.isToSend);
          fbb.addBool(3, object.hasBeenSent);
          fbb.addBool(4, object.doesImageHaveCorrectExifTags);
          fbb.addInt64(5, object.sequence.targetId);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (obx.Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = SequencePictureDto()
            ..id = const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0)
            ..localFilePath = const fb.StringReader(asciiOptimization: true)
                .vTableGet(buffer, rootOffset, 6, '')
            ..isToSend =
                const fb.BoolReader().vTableGet(buffer, rootOffset, 8, false)
            ..hasBeenSent =
                const fb.BoolReader().vTableGet(buffer, rootOffset, 10, false)
            ..doesImageHaveCorrectExifTags =
                const fb.BoolReader().vTableGet(buffer, rootOffset, 12, false);
          object.sequence.targetId =
              const fb.Int64Reader().vTableGet(buffer, rootOffset, 14, 0);
          object.sequence.attach(store);
          return object;
        })
  };

  return obx_int.ModelDefinition(model, bindings);
}

/// [SequenceDto] entity fields to define ObjectBox queries.
class SequenceDto_ {
  /// See [SequenceDto.id].
  static final id =
      obx.QueryIntegerProperty<SequenceDto>(_entities[0].properties[0]);

  /// See [SequenceDto.panoramaxSequenceId].
  static final panoramaxSequenceId =
      obx.QueryStringProperty<SequenceDto>(_entities[0].properties[1]);

  /// See [SequenceDto.name].
  static final name =
      obx.QueryStringProperty<SequenceDto>(_entities[0].properties[2]);

  /// See [SequenceDto.creationDate].
  static final creationDate =
      obx.QueryDateProperty<SequenceDto>(_entities[0].properties[3]);

  /// see [SequenceDto.pictures]
  static final pictures =
      obx.QueryBacklinkToMany<SequencePictureDto, SequenceDto>(
          SequencePictureDto_.sequence);
}

/// [SequencePictureDto] entity fields to define ObjectBox queries.
class SequencePictureDto_ {
  /// See [SequencePictureDto.id].
  static final id =
      obx.QueryIntegerProperty<SequencePictureDto>(_entities[1].properties[0]);

  /// See [SequencePictureDto.localFilePath].
  static final localFilePath =
      obx.QueryStringProperty<SequencePictureDto>(_entities[1].properties[1]);

  /// See [SequencePictureDto.isToSend].
  static final isToSend =
      obx.QueryBooleanProperty<SequencePictureDto>(_entities[1].properties[2]);

  /// See [SequencePictureDto.hasBeenSent].
  static final hasBeenSent =
      obx.QueryBooleanProperty<SequencePictureDto>(_entities[1].properties[3]);

  /// See [SequencePictureDto.doesImageHaveCorrectExifTags].
  static final doesImageHaveCorrectExifTags =
      obx.QueryBooleanProperty<SequencePictureDto>(_entities[1].properties[4]);

  /// See [SequencePictureDto.sequence].
  static final sequence =
      obx.QueryRelationToOne<SequencePictureDto, SequenceDto>(
          _entities[1].properties[5]);
}
